<?php

class poll_class extends general_poll_class{
    
	public $plugin_page;
	
	public $plugin_page_base;
	
	public $table;
	
	public $table2;
	
	public $table3;
	
    public function __construct(){
      $this->plugin_page_base = 'easy_polls';
	  $this->plugin_page = admin_url('admin.php?page='.$this->plugin_page_base);
	  $this->table = 'easy_poll_q';
	  $this->table2 = 'easy_poll_a';
	  $this->table3 = 'easy_poll_votes';
    }
	
	public function get_table_colums(){
		$colums = array(
		'p_id' => __('ID','wp-easy-poll-afo'),
		'p_ques' => __('Poll','wp-easy-poll-afo'),
		'p_author' => __('Author','wp-easy-poll-afo'),
		'p_start' => __('Start','wp-easy-poll-afo'),
		'p_end' => __('End','wp-easy-poll-afo'),
		'p_status' => __('Status','wp-easy-poll-afo'),
		'action' => __('Action','wp-easy-poll-afo')
		);
		return $colums;
	}
	
	public function add_message($msg,$class = 'error'){
		start_session_if_not_started();
		$_SESSION['msg'] = $msg;
	}
	
	public function show_message(){
		start_session_if_not_started();
		if(isset($_SESSION['msg']) and $_SESSION['msg']){
			echo '<div class="updated"><p>'.$_SESSION['msg'].'</p></div>';
			$_SESSION['msg'] = '';
		}
	}
	
	public function table_start(){
		return '<table class="wp-list-table widefat">';
	} 
    
	public function table_end(){
		return '</table>';
	}
	
	public function get_table_header(){
		$ret = '';
		$header = $this->get_table_colums();
		$ret .= '<thead>';
		$ret .= '<tr>';
		foreach($header as $key => $value){
			$ret .= '<th>'.$value.'</th>';
		}
		$ret .= '</tr>';
		$ret .= '</thead>';
		return $ret;		
	}
	
	public function table_td_column($value){

		$ret = '';
		if(is_array($value)){
			foreach($value as $vk => $vv){
				$ret .= $this->row_data($vk,$vv,$value);
			}
		}
		
		$ret .= $this->row_actions($value['p_id']);
		return $ret;
	}
	
	public function row_actions($id){
		return '<td><a href="'.$this->plugin_page.'&action=edit&id='.$id.'">'.__('Edit','eca').'</a> <a onclick="return confirmRemove();" href="'.wp_nonce_url( $this->plugin_page.'&action=delete_p&id='.$id, 'poll_nonce_action'.$id, 'poll_nonce' ).'">'.__('Delete','eca').'</a></td>';
	}
	
	public function add_link(){
		return '<a href="'.$this->plugin_page.'&action=add" class="add-new-h2">'.__('Add','eca').'</a>';
	}
	
	public function poll_report_link($id){
		return '<a href="'.$this->plugin_page.'&action=poll_report&p_id='.$id.'">'.__('View Report','eca').'</a>';
	}
		
	public function row_data($key,$value,$all){
		$sh = false;
		switch ($key){
			case 'p_id':
			$v = $value.' ('.$this->poll_report_link($value).')';
			$sh = true;
			break;
			case 'p_ques':
			$v = stripslashes($value);
			$sh = true;
			break;
			case 'p_author':
			$v = $this->get_user_name_or_email($value);
			$sh = true;
			break;
			case 'p_start':
			$v = $value;
			$sh = true;
			break;
			case 'p_end':
			$v = $value;
			$sh = true;
			break;
			case 'p_status':
			$v = $this->poll_status_admin($all['p_id']).' <strong>('.$value.')</strong>';
			$sh = true;
			break;
			default:
			//$v = $value; uncomment this line on your own risk
			break;
		}
		if($sh){
			return '<td>'.$v.'</td>';
		}
	}
	
	public function get_table_body($data){
		$ret = '';
		$cnt = 0;
		if(is_array($data)){
			$ret .= '<tbody id="the-list">';
			foreach($data as $k => $v){
				$ret .= '<tr class="'.($cnt%2==0?'alternate':'').'">';
				$ret .= $this->table_td_column($v);
				$ret .= '</tr>';
				$cnt++;
			}
			$ret .= '</tbody>';
		}
		return $ret;
	}
	
	public function get_single_row_data($id){
		global $wpdb;
		$query = $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix.$this->table." where p_id = %d", $id );
		$result = $wpdb->get_row( $query, ARRAY_A );
		return $result;
	}
	
	public function get_poll_answers_data($id){
		global $wpdb;
		$query = $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix.$this->table2." where p_id = %d order by a_order", $id );
		$result = $wpdb->get_results( $query, ARRAY_A );
		return $result;
	}
	
	public function search_form(){
	?>
	<form name="sub_search" action="" method="get">
	<input type="hidden" name="page" value="<?php echo $this->plugin_page_base;?>" />
	<input type="hidden" name="search" value="p_search" />
	<table width="100%" border="0">
	  <tr>
		<td><input type="text" name="p_ques" value="<?php echo sanitize_text_field(@$_REQUEST['p_ques']);?>" placeholder="<?php _e('Poll','wp-easy-poll-afo');?>"/> <input type="submit" name="submit" value="<?php _e('Filter','wp-easy-poll-afo');?>" class="button"/></td>
	  </tr>
	</table>
	</form>
	<?php
	}
	
	public function process_selector($v = 'data'){
		echo '<input type="hidden" name="action" value="'.$v.'" />';
	}
	
	public function get_poll_author_selected($sel_id = ''){
		$authors = get_users();
		$ret = '';
		foreach ( $authors as $author ) {
			if($sel_id == $author->ID){
				$ret .= '<option value="'.$author->ID.'" selected="selected">'.esc_html($author->user_email).'</option>';
			} else {
				$ret .= '<option value="'.$author->ID.'">'.esc_html($author->user_email).'</option>';
			}
		}
		return $ret;
	}
	
	public function get_poll_status_selected($sel_id = ''){
		$statuses = array('Active','Inactive','Deleted');
		$ret = '';
		foreach ( $statuses as $status ) {
			if($sel_id == $status){
				$ret .= '<option value="'.$status.'" selected="selected">'.$status.'</option>';
			} else {
				$ret .= '<option value="'.$status.'">'.$status.'</option>';
			}
		}
		return $ret;
	}
	
	public function dateTimeJsCall($id = 'datetime'){?>
	 <script type="text/javascript">
		jQuery(function() {
			jQuery( "#<?php echo $id;?>" ).datetimepicker({
				dateFormat: "yy-mm-dd",
				timeFormat: "HH:mm:ss"
			});
		});
	</script>
	<?php }
	
	public function jQueryDynamicAnswersJs(){?>
	 <script type="text/javascript">
	jQuery(document).ready(function() {
		var max_fields      = 5; 
		var wrapper         = jQuery(".ans_fields_wrap"); 
		var add_button      = jQuery(".add_more_ans"); 
		
		var x = wrapper.children('div').length; 
		jQuery(add_button).click(function(e){ 
			e.preventDefault();
			if(x < max_fields){ 
				x++; 
				jQuery(wrapper).append('<div><input type="text" name="p_anss[]" size="50"/> <a href="#" class="remove_field"><?php echo _e('Remove','wp-easy-poll-afo');?></a></div>'); 
			}
		});
	   
		jQuery(wrapper).on("click",".remove_field", function(e){
			e.preventDefault(); jQuery(this).parent('div').remove(); x--;
		})
	});
	</script>
	<?php }
	
	
	public function add(){
	$this->show_message();
	?>
	<form name="f" action="" method="post">
	<?php $this->process_selector('p_add');?>
	<?php wp_nonce_field( 'poll_nonce_action', 'poll_nonce_field' ); ?>
	<h3><?php _e('Poll Add','wp-easy-poll-afo');?></h3>
	<table width="100%" border="0" cellspacing="10" class="ap-table">
		<tr>
			<td width="300"><strong><?php _e('Poll Question','wp-easy-poll-afo');?></strong></td>
			<td><input type="text" name="p_ques" size="50" /></td>
		</tr>
		<tr>
			<td><strong><?php _e('Author','wp-easy-poll-afo');?></strong></td>
			<td><select name="p_author"><?php echo $this->get_poll_author_selected();?></select></td>
		</tr>
		<tr>
			<td><strong><?php _e('Start','wp-easy-poll-afo');?></strong></td>
			<td><input type="text" name="p_start" id="p_start" required="required"/><?php $this->dateTimeJsCall('p_start');?></td>
		</tr>
		<tr>
			<td><strong><?php _e('End','wp-easy-poll-afo');?></strong></td>
			<td><input type="text" name="p_end" id="p_end" required="required"/><?php $this->dateTimeJsCall('p_end');?></td>
		</tr>
		<tr>
			<td><strong><?php _e('Status','wp-easy-poll-afo');?></strong></td>
			<td><select name="p_status"><?php echo $this->get_poll_status_selected();?></select></td>
		</tr>
		<tr>
			<td><h3><?php _e('Poll Answers','wp-easy-poll-afo');?></h3></td>
			<td><button class="add_more_ans button"><?php _e('Add More Answers','wp-easy-poll-afo');?></button></td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><div class="ans_fields_wrap"><div><input type="text" name="p_anss[]" size="50"></div></div></td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><input type="submit" name="submit" value="<?php _e('Submit','wp-easy-poll-afo');?>" class="button" /></td>
		</tr>
	</table>
	</form>
	<?php
	$this->jQueryDynamicAnswersJs();
	}	
	
	public function edit(){
	$id = sanitize_text_field($_REQUEST['id']);
	$data = $this->get_single_row_data($id);
	$data1 = $this->get_poll_answers_data($id);
	$this->show_message();
	?>
	<form name="f" action="" method="post">
	<?php $this->process_selector('p_edit');?>
	<input type="hidden" name="p_id" id="p_id" value="<?php echo $id;?>" />
	<?php wp_nonce_field( 'poll_nonce_action', 'poll_nonce_field' ); ?>
	<h3><?php _e('Poll Edit','wp-easy-poll-afo');?></h3>
	<table width="100%" border="0" cellspacing="10" class="ap-table">
		<tr>
			<td width="300"><strong><?php _e('Poll Question','wp-easy-poll-afo');?></strong></td>
			<td><input type="text" name="p_ques" value="<?php echo stripslashes($data['p_ques']);?>" size="50"/></td>
		</tr>
		<tr>
			<td><strong><?php _e('Author','wp-easy-poll-afo');?></strong></td>
			<td><select name="p_author"><?php echo $this->get_poll_author_selected($data['p_author']);?></select></td>
		</tr>
		<tr>
			<td><strong><?php _e('Start','wp-easy-poll-afo');?></strong></td>
			<td><input type="text" name="p_start" id="p_start" value="<?php echo $data['p_start'];?>" required="required" /><?php $this->dateTimeJsCall('p_start');?></td>
		</tr>
		<tr>
			<td><strong><?php _e('End','wp-easy-poll-afo');?></strong></td>
			<td><input type="text" name="p_end" id="p_end" value="<?php echo $data['p_end'];?>" required="required"/><?php $this->dateTimeJsCall('p_end');?><input type="button" name="submit" value="<?php _e('Save','eca');?>" class="button" onclick="updatePollEndDate();" /></td>
		</tr>
		<tr>
			<td><strong><?php _e('Status','wp-easy-poll-afo');?></strong></td>
			<td><select name="p_status" id="p_status"><?php echo $this->get_poll_status_selected($data['p_status']);?></select>
			<input type="button" name="submit" value="<?php _e('Save','eca');?>" class="button" onclick="updatePollStatus();" />
			</td>
		</tr>
		<tr>
			<td><h3><?php _e('Poll Answers','wp-easy-poll-afo');?></h3></td>
			<td><button class="add_more_ans button"><?php _e('Add More Answers','wp-easy-poll-afo');?></button></td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><div class="ans_fields_wrap">
			<?php 
			if(is_array($data1)){
				foreach($data1 as $key => $value){
					echo '<div><input type="text" name="p_anss[]" value="'.stripslashes($value['a_ans']).'" size="50"> <a href="#" class="remove_field">'.__('Remove','wp-easy-poll-afo').'</a></div>';
				}
			}
			?></div>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td>
			<?php if($this->is_poll_started($id)){
			_e('Poll already started & other than the end date poll cannot be updated now!','wp-easy-poll-afo');
			} else { ?>
			<input type="submit" name="submit" value="<?php _e('Submit','eca');?>" class="button" />
			<?php } ?>
			</td>
		</tr>
        <tr>
			<td><strong>Shortcode</strong></td>
			<td><strong>[easypoll id="<?php echo $id;?>"]</strong></td>
		</tr>
	</table>
	</form>
	<?php
	$this->jQueryDynamicAnswersJs();
	}	
	
	public function lists(){
	$this->show_message();
	?>
	<h3><?php _e('Polls','wp-easy-poll-afo');?> <?php echo $this->add_link();?> <span style="float:right; font-size:16px;"><?php _e('Export to XLS available with PRO Version','wp-easy-poll-afo');?></span></h3>
	<?php
		global $wpdb;
		
		if(isset($_REQUEST['search']) and $_REQUEST['search'] == 'p_search'){
			if(isset($_REQUEST['p_ques'])){
				$query = $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix.$this->table." where p_status <> 'Deleted' and p_ques like %s order by p_added desc", '%'.sanitize_text_field($_REQUEST['p_ques']).'%' );
			}
		} else {
			$query = "SELECT * FROM ".$wpdb->prefix.$this->table." where p_status <> 'Deleted' order by p_added desc";
		}
		
		$ap = new afo_paginate(10);
		$data = $ap->initialize($query,sanitize_text_field(@$_REQUEST['paged']));
		
		echo $this->search_form();
		echo $this->table_start();
		echo $this->get_table_header();
		echo $this->get_table_body($data);
		echo $this->table_end();
		
		echo '<div style="margin-top:10px;">';
		echo $ap->paginate();
		echo '</div>';
		
	}
	
	public function poll_report($p_id = ''){
	?>
	<h3><?php _e('Poll Report','wp-easy-poll-afo');?></h3>
	<table width="100%" border="0" cellspacing="10" class="ap-table">
		<tr>
			<td><?php echo $this->get_report($p_id);?></td>
		</tr>
	</table>
	<?php
	}	
	
	public function get_report($p_id = ''){
		if($p_id == ''){
			return;
		}
		global $wpdb;
		$ret = '';
		$query =  $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix.$this->table3." where p_id = %d order by v_added desc", $p_id );
		$result = $wpdb->get_results( $query, ARRAY_A );
		$p_ans_data = $this->get_poll_answers_data($p_id);
		
		$ret .= '<h3>'.$this->get_ques_from_p_id($p_id).'</h3>';
		$ret .= '<table width="100%" border="0">';
		foreach ($p_ans_data as $key => $value){
		$ret .= '<tr>';
		$ret .= '<td><strong>'.stripslashes($value['a_ans']).$this->answer_data_for_csv($p_id,$value['a_id']).'</strong></td>';
		$ret .= '</tr>';
		}
		$ret .= '</table>';
		
		$ret .= '<table width="100%" border="0">';
		$ret .= '<tr>';
		$ret .= '<td><strong>'.__('Answer','wp-easy-poll-afo').'</strong></td>';
		$ret .= '<td><strong>'.__('User','wp-easy-poll-afo').'</strong></td>';
		$ret .= '<td><strong>'.__('IP','wp-easy-poll-afo').'</strong></td>';
		$ret .= '<td><strong>'.__('Date','wp-easy-poll-afo').'</strong></td>';
		$ret .= '</tr>';
		foreach ($result as $key => $value){
		$ret .= '<tr>';
		$ret .= '<td>'.$this->get_ans_from_a_id($value['a_id']).'</td>';
		$ret .= '<td>'.$this->get_user_name_or_email($value['user_id']).'</td>';
		$ret .= '<td>'.$value['user_ip'].'</td>';
		$ret .= '<td>'.$value['v_added'].'</td>';
		$ret .= '</tr>';
		} 
 		$ret .= '</table>';
		return $ret;
	}
	
	public function start_wrap(){
		echo '<div class="wrap">';
	}
	
	public function end_wrap(){
		echo '</div>';
	}
	
	
    public function display_list() {
		$this->start_wrap();
		if(isset($_REQUEST['action']) and $_REQUEST['action'] == 'edit'){
			$this->edit();
		} elseif(isset($_REQUEST['action']) and $_REQUEST['action'] == 'add'){
			$this->add();
		} elseif(isset($_REQUEST['action']) and $_REQUEST['action'] == 'poll_report'){
			$this->poll_report($_REQUEST['p_id']);
		} else{
			$this->lists();
		}
		$this->end_wrap();
  }
}
