<?php
class poll_settings {

	public function __construct() {
		$this->load_settings();
	}
	
	public function easy_poll_afo_options_save_settings(){
		if(isset($_POST['option']) and $_POST['option'] == "easy_poll_afo_options_save_settings"){
			if ( ! isset( $_POST['easy_poll_afo_options_save_action_field'] ) || ! wp_verify_nonce( $_POST['easy_poll_afo_options_save_action_field'], 'easy_poll_afo_options_save_action' ) ) {
			   wp_die( 'Sorry, your nonce did not verify.');
			} 
			
			if( isset($_POST['poll_result_after_it_ends']) ){
				update_option( 'poll_result_after_it_ends', sanitize_text_field($_POST['poll_result_after_it_ends']) );
			} else {
				delete_option( 'poll_result_after_it_ends' );
			}
			
			if( isset($_POST['poll_share_enable_facebook']) ){
				update_option( 'poll_share_enable_facebook', sanitize_text_field($_POST['poll_share_enable_facebook']) );
			} else {
				delete_option( 'poll_share_enable_facebook' );
			}
			
			if( isset($_POST['poll_share_enable_twitter']) ){
				update_option( 'poll_share_enable_twitter', sanitize_text_field($_POST['poll_share_enable_twitter']) );
			} else {
				delete_option( 'poll_share_enable_twitter' );
			}
			
			if( isset($_POST['poll_share_enable_google']) ){
				update_option( 'poll_share_enable_google', sanitize_text_field($_POST['poll_share_enable_google']) );
			} else {
				delete_option( 'poll_share_enable_google' );
			}
			
			if( isset($_POST['poll_share_enable_linkedin']) ){
				update_option( 'poll_share_enable_linkedin', sanitize_text_field($_POST['poll_share_enable_linkedin']) );
			} else {
				delete_option( 'poll_share_enable_linkedin' );
			}
			
			if( isset($_POST['poll_share_enable_email']) ){
				update_option( 'poll_share_enable_email', sanitize_text_field($_POST['poll_share_enable_email']) );
			} else {
				delete_option( 'poll_share_enable_email' );
			}
			
			$GLOBALS['msg'] = __('Data successfully updated.','wp-easy-poll-afo');
		}
	}
	
	public function help_support(){ ?>
	<table width="100%" border="0" class="ap-table">
	  <tr>
		<td align="right"><a href="https://www.aviplugins.com/support.php" target="_blank">Help and Support</a> <a href="https://www.aviplugins.com/rss/news.xml" target="_blank"><img src="<?php echo  plugins_url( WPEPA_DIR_NAME . '/assets/images/rss.png' );?>" style="vertical-align: middle;" alt="RSS"></a></td>
	  </tr>
	</table>
	<?php
	}
	
	public function donate(){	?>
	<table width="100%" border="0" class="ap-table">
	 <tr>
	 <td align="right"><a href="https://www.aviplugins.com/donate/" target="_blank">Donate</a> <img src="<?php echo  plugins_url( WPEPA_DIR_NAME . '/assets/images/paypal.png' );?>" style="vertical-align: middle;" alt="PayPal"></td>
	  </tr>
	</table>
	<?php
	}
	
	public function  easy_poll_settings_afo_options () {
	echo '<div class="wrap">';
	global $wpdb;
	$poll_result_after_it_ends = get_option('poll_result_after_it_ends');
	
	$poll_share_enable_facebook = get_option('poll_share_enable_facebook');
	$poll_share_enable_twitter = get_option('poll_share_enable_twitter');
	$poll_share_enable_google = get_option('poll_share_enable_google');
	$poll_share_enable_linkedin = get_option('poll_share_enable_linkedin');
	$poll_share_enable_email = get_option('poll_share_enable_email');
	
	$this->show_message();
	$this->wp_easy_poll_pro_add();
	$this->help_support();
	?>
	<form name="f" method="post" action="">
	<input type="hidden" name="option" value="easy_poll_afo_options_save_settings" />
    <?php wp_nonce_field( 'easy_poll_afo_options_save_action', 'easy_poll_afo_options_save_action_field' ); ?>
	<table border="0" width="100%" class="ap-table">
	  
      <tr>
		<td width="300"><h3><?php _e('Poll Settings','wp-easy-poll-afo');?></h3></td>
		<td>&nbsp;</td>
	  </tr>
      
      <tr>
		<td colspan="2">
         <div class="ap-tabs">
            <div class="ap-tab"><?php _e('General','wp-easy-poll-afo');?></div>
            <div class="ap-tab"><?php _e('Social Shares','wp-easy-poll-afo');?></div>
        </div>

         <div class="ap-tabs-content">
            <div class="ap-tab-content">
            <table width="100%">
              <tr>
                <td valign="top" width="300"><strong><?php _e('View Poll Result After Poll Ends','wp-easy-poll-afo');?></strong></td>
                <td><input type="checkbox" name="poll_result_after_it_ends" value="Yes" <?php echo $poll_result_after_it_ends == 'Yes'?'checked="checked"':'';?> /><p><?php _e('Check this so that users can view the poll results only after the poll ends.','wp-easy-poll-afo');?></p></td>
              </tr>
              <tr>
                <td>&nbsp;</td>
                <td><input type="submit" name="submit" value="<?php _e('Save','wp-easy-poll-afo');?>" class="button button-primary button-large" /></td>
              </tr>
              </table>
        	</div>
            <div class="ap-tab-content">
            <table width="100%">
              <tr>
                <td valign="top" width="300"><strong><?php _e('Facebook','wp-easy-poll-afo');?></strong></td>
                <td><input type="checkbox" name="poll_share_enable_facebook" value="Yes" <?php echo $poll_share_enable_facebook == 'Yes'?'checked="checked"':'';?> /><i><?php _e('Enable Facebook Share','wp-easy-poll-afo');?></i></td>
              </tr>
              <tr>
                <td valign="top" width="300"><strong><?php _e('Twitter','wp-easy-poll-afo');?></strong></td>
                <td><input type="checkbox" name="poll_share_enable_twitter" value="Yes" <?php echo $poll_share_enable_twitter == 'Yes'?'checked="checked"':'';?> /><i><?php _e('Enable Twitter Share','wp-easy-poll-afo');?></i></td>
              </tr>
              <tr>
                <td valign="top" width="300"><strong><?php _e('Google','wp-easy-poll-afo');?></strong></td>
                <td><input type="checkbox" name="poll_share_enable_google" value="Yes" <?php echo $poll_share_enable_google == 'Yes'?'checked="checked"':'';?> /><i><?php _e('Enable Google Share','wp-easy-poll-afo');?></i></td>
              </tr>
              <tr>
                <td valign="top" width="300"><strong><?php _e('Linked In','wp-easy-poll-afo');?></strong></td>
                <td><input type="checkbox" name="poll_share_enable_linkedin" value="Yes" <?php echo $poll_share_enable_linkedin == 'Yes'?'checked="checked"':'';?> /><i><?php _e('Enable Linked In Share','wp-easy-poll-afo');?></i></td>
              </tr>
              <tr>
                <td valign="top" width="300"><strong><?php _e('Email','wp-easy-poll-afo');?></strong></td>
                <td><input type="checkbox" name="poll_share_enable_email" value="Yes" <?php echo $poll_share_enable_email == 'Yes'?'checked="checked"':'';?> /> <i><?php _e('Enable Email In Share','wp-easy-poll-afo');?></i></td>
              </tr>
               <tr>
                <td>&nbsp;</td>
                <td>&nbsp;</td>
              </tr>
              <tr>
                <td>&nbsp;</td>
                <td><input type="submit" name="submit" value="<?php _e('Save','wp-easy-poll-afo');?>" class="button button-primary button-large" /></td>
              </tr>
              </table>
        	</div>
        </div>
      </td>
      </tr>
      <tr>
		<td>&nbsp;</td>
		<td>&nbsp;</td>
	  </tr>
	</table>
	</form>
    
     <table border="0" width="100%" class="ap-table">
      <tr>
		<td>
        <h3><?php _e('Shortcode','wp-easy-poll-afo');?></h3>
        <p>1. <strong>[easypoll id="1"]</strong> Use this Shortcode to display poll in a page. (If you don't want to use the widget). ID is required. ID is poll id.</p>
        <p>2. <strong>[easypolllist_all]</strong> Use this Shortcode to display all polls in a single page.</p>
        </td>
	  </tr>
	</table>
    
	<?php 
	$this->donate();
	echo '</div>';
	}
	
	public function wp_easy_poll_pro_add(){ ?>
	<table border="0" width="100%" class="ap-table">
  <tr>
    <td><p>The <strong>PRO</strong> version of this plugin <strong><a href="https://www.aviplugins.com/wp-easy-poll-pro/" target="_blank">WP Easy Poll PRO</a></strong> has additional features. <strong>1)</strong> <strong>Export/ Email</strong> voting results to your users. <strong>2)</strong> Let users <strong>Create Polls</strong> from front end. <strong>3)</strong> <strong>Notification</strong> Email will be sent to User and Admin when new Polls are created from front end. <strong>4)</strong> Choose color for the voting result bar as per your liking. Get it from <a href="https://www.aviplugins.com/wp-easy-poll-pro/" target="_blank">here</a> for <strong>USD 2.00</strong> </p></td>
  </tr>
</table>
	<?php 
	}
		
	public function show_message(){
		if(isset($GLOBALS['msg'])){
			echo '<div class="updated"><p>'.$GLOBALS['msg'].'</p></div>';
			$GLOBALS['msg'] = '';
		}
	}
	
	public function easy_poll_scripts_admin() {
		wp_enqueue_script( 'jquery' );	  
		wp_enqueue_script( 'jquery-ui-timepicker-addon', plugins_url( WPEPA_DIR_NAME . '/assets/jquery-ui-timepicker-addon.js' ), array('jquery-ui-core' ,'jquery-ui-datepicker', 'jquery-ui-slider') );
		wp_enqueue_script( 'easy-poll-js', plugins_url( WPEPA_DIR_NAME . '/assets/easy-poll-js.js' ) );
		wp_enqueue_style( 'jquery-ui', plugins_url( WPEPA_DIR_NAME . '/assets/jquery-ui.css' ) );
		wp_enqueue_style( 'style_easy_poll', plugins_url( WPEPA_DIR_NAME . '/assets/style_easy_poll.css' ) );
		
		wp_enqueue_script( 'jquery.cookie', plugins_url( WPEPA_DIR_NAME . '/assets/jquery.cookie.js' ) );
		wp_enqueue_script( 'ap-tabs', plugins_url( WPEPA_DIR_NAME . '/assets/ap-tabs.js' ) );
		
	}
	
	public function easy_poll_scripts() {
		wp_enqueue_script( 'jquery' );	  
		wp_enqueue_script( 'jquery-ui-timepicker-addon', plugins_url( WPEPA_DIR_NAME . '/assets/jquery-ui-timepicker-addon.js' ), array('jquery-ui-core' ,'jquery-ui-datepicker', 'jquery-ui-slider') );
		wp_enqueue_script( 'easy-poll-js', plugins_url( WPEPA_DIR_NAME . '/assets/easy-poll-js.js' ) );
		wp_enqueue_style( 'jquery-ui', plugins_url( WPEPA_DIR_NAME . '/assets/jquery-ui.css' ) );
		wp_enqueue_style( 'style_easy_poll', plugins_url( WPEPA_DIR_NAME . '/assets/style_easy_poll.css' ) );
		wp_enqueue_style( 'font-awesome', '//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css' );
	}

	public function wp_easy_poll_text_domain(){
		load_plugin_textdomain('wp-easy-poll-afo', FALSE, basename( dirname( __FILE__ ) ) .'/languages');
	}
	
	public function easy_polls_afo_options(){
		$pc = new poll_class();
		$pc->display_list();
	}
	
	public function easy_poll_afo_menu () {
		add_options_page( 'Easy Poll', 'Easy Poll Settings', 'activate_plugins', 'easy_poll_afo', array( $this,'easy_poll_settings_afo_options' ) );
		add_menu_page( 'Polls', 'Polls', 'activate_plugins', 'easy_polls', array( $this,'easy_polls_afo_options' ), 'dashicons-chart-bar' );	
	}
	
	public function load_settings(){
		add_action( 'admin_menu' , array( $this, 'easy_poll_afo_menu' ) );
		add_action( 'admin_init', array( $this, 'easy_poll_afo_options_save_settings' ) );
		add_action( 'wp_enqueue_scripts', array( $this, 'easy_poll_scripts' ) );
		add_action( 'admin_enqueue_scripts', array( $this, 'easy_poll_scripts_admin' ) );
		add_action( 'plugins_loaded',  array( $this, 'wp_easy_poll_text_domain' ) );
	}

}
