<?php
/*
Plugin Name: WP Easy Poll
Plugin URI: https://wordpress.org/plugins/wp-easy-poll-afo/
Description: This is an easy poll plugin. Polls can be created from admin panel and displayed as widget in frontend. Users can submit vote and view poll results from frontend.
Version: 2.2.4
Text Domain: wp-easy-poll-afo
Domain Path: /languages
Author: aviplugins.com
Author URI: https://www.aviplugins.com/
*/

/**
	  |||||   
	<(`0_0`)> 	
	()(afo)()
	  ()-()
**/

define( 'WPEPA_DIR_NAME', 'wp-easy-poll-afo' );

function plug_load_wp_easy_poll_afo(){
	
	include_once dirname( __FILE__ ) . '/includes/class_settings.php';
	include_once dirname( __FILE__ ) . '/includes/class_general.php';
	include_once dirname( __FILE__ ) . '/includes/class_paginate.php';
	include_once dirname( __FILE__ ) . '/includes/class_message.php';
	include_once dirname( __FILE__ ) . '/includes/class_poll.php';
	
	include_once dirname( __FILE__ ) . '/poll_data.php';
	include_once dirname( __FILE__ ) . '/poll_widget.php';
	include_once dirname( __FILE__ ) . '/easy_poll_sc.php';
	include_once dirname( __FILE__ ) . '/functions.php';
	
	new poll_settings;
}

class wp_easy_poll_load {
	function __construct() {
		plug_load_wp_easy_poll_afo();
	}
}
new wp_easy_poll_load;

add_action( 'admin_init', 'process_poll_data' );

add_action( 'widgets_init', function(){ register_widget( 'poll_wid' ); } );

add_action( 'init', 'poll_validate' );

add_shortcode( 'easypoll', 'wp_easy_poll_shortcode' );
add_shortcode( 'easypolllist_all', 'wp_easy_polls_active_shortcode' );

class wp_easy_poll_init {
     static function install() {
        global $wpdb;
		$create_table = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."easy_poll_q` (
		  `p_id` int(11) NOT NULL AUTO_INCREMENT,
		  `p_ques` varchar(255) NOT NULL,
		  `p_author` int(11) NOT NULL,
		  `p_start` datetime NOT NULL,
		  `p_end` datetime NOT NULL,
		  `p_added` datetime NOT NULL,
		  `p_status` enum('Active','Inactive','Deleted') NOT NULL,
		  PRIMARY KEY (`p_id`)
		)";
		$wpdb->query($create_table);
		$create_table = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."easy_poll_a` (
		  `a_id` int(11) NOT NULL AUTO_INCREMENT,
		  `p_id` int(11) NOT NULL,
		  `a_ans` varchar(255) NOT NULL,
		  `a_order` int(11) NOT NULL,
		  PRIMARY KEY (`a_id`)
		)";
		$wpdb->query($create_table);
		$create_table = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."easy_poll_votes` (
		  `v_id` int(11) NOT NULL AUTO_INCREMENT,
		  `p_id` int(11) NOT NULL,
		  `a_id` int(11) NOT NULL,
		  `user_id` int(11) NOT NULL,
		  `user_ip` varchar(50) NOT NULL,
		  `v_added` datetime NOT NULL,
		  PRIMARY KEY (`v_id`)
		)";
		$wpdb->query($create_table);
     }
	 static function uninstall() {}
}
register_activation_hook( __FILE__, array( 'wp_easy_poll_init', 'install' ) );

register_deactivation_hook( __FILE__, array( 'wp_easy_poll_init', 'uninstall' ) );
